Lucene++ - a full-featured, c++ search engine
API Documentation

Public Member Functions | Static Public Member Functions
Lucene::SimpleFSDirectory Class Reference

A straightforward implementation of FSDirectory using std::ofstream and std::ifstream. More...

`#include <SimpleFSDirectory.h>`

Inheritance diagram for Lucene::SimpleFSDirectory:

## Public Member Functions

| SimpleFSDirectory (const String &path, const LockFactoryPtr &lockFactory=LockFactoryPtr())
| Create a new SimpleFSDirectory for the named location and NativeFSLockFactory. More...
virtual | ~SimpleFSDirectory ()
virtual String | getClassName ()
boost::shared_ptr< SimpleFSDirectory > | shared_from_this ()
virtual IndexOutputPtr | createOutput (const String &name)
| Creates an IndexOutput for the file with the given name. More...
virtual IndexInputPtr | openInput (const String &name)
| Returns a stream reading an existing file, with the specified read buffer size. The particular Directory implementation may ignore the buffer size. More...
virtual IndexInputPtr | openInput (const String &name, int32_t bufferSize)
| Creates an IndexInput for the file with the given name. More...
Public Member Functions inherited from Lucene::FSDirectory
virtual | ~FSDirectory ()
boost::shared_ptr< FSDirectory > | shared_from_this ()
void | createDir ()
| Create file system directory. More...
String | getFile ()
| Return file system directory. More...
void | setReadChunkSize (int32_t chunkSize)
| Sets the maximum number of bytes read at once from the underlying file during IndexInput#readBytes. The default value is DEFAULT_READ_CHUNK_SIZE. Changes to this value will not impact any already-opened IndexInputs. You should call this before attempting to open an index on the directory. This value should be as large as possible to reduce any possible performance impact. More...
int32_t | getReadChunkSize ()
| The maximum number of bytes to read at once from the underlying file during IndexInput#readBytes. More...
virtual HashSet< String > | listAll ()
| Lists all files (not subdirectories) in the directory. More...
virtual bool | fileExists (const String &name)
| Returns true if a file with the given name exists. More...
virtual uint64_t | fileModified (const String &name)
| Returns the time the named file was last modified. More...
virtual void | touchFile (const String &name)
| Set the modified time of an existing file to now. More...
virtual void | deleteFile (const String &name)
| Removes an existing file in the directory. More...
virtual int64_t | fileLength (const String &name)
| Returns the length in bytes of a file in the directory. More...
virtual void | sync (const String &name)
| Ensure that any writes to this file are moved to stable storage. Lucene uses this to properly commit changes to the index, to prevent a machine/OS crash from corrupting the index. More...
virtual String | getLockID ()
| Return a string identifier that uniquely differentiates this Directory instance from other Directory instances. More...
virtual void | close ()
| Closes the store to future operations. More...
virtual String | toString ()
| For debug output. More...
Public Member Functions inherited from Lucene::Directory
| Directory ()
virtual | ~Directory ()
boost::shared_ptr< Directory > | shared_from_this ()
virtual LockPtr | makeLock (const String &name)
| Construct a Lock. More...
void | clearLock (const String &name)
| Attempt to clear (forcefully unlock and remove) the specified lock. Only call this at a time when you are certain this lock is no longer in use. More...
void | setLockFactory (const LockFactoryPtr &lockFactory)
| Set the LockFactory that this Directory instance should use for its locking implementation. Each * instance of LockFactory should only be used for one directory (ie, do not share a single instance across multiple Directories). More...
LockFactoryPtr | getLockFactory ()
| Get the LockFactory that this Directory instance is using for its locking implementation. Note that this may be null for Directory implementations that provide their own locking implementation. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::FSDirectory
static String | _getClassName ()
static FSDirectoryPtr | open (const String &path)
| Creates an FSDirectory instance. More...
static FSDirectoryPtr | open (const String &path, const LockFactoryPtr &lockFactory)
| Just like open(File), but allows you to also specify a custom LockFactory. More...
static HashSet< String > | listAll (const String &dir)
| Lists all files (not subdirectories) in the directory. More...
static uint64_t | fileModified (const String &directory, const String &name)
| Returns the time the named file was last modified. More...
Static Public Member Functions inherited from Lucene::Directory
static String | _getClassName ()
static void | copy (const DirectoryPtr &src, const DirectoryPtr &dest, bool closeDirSrc)
| Copy contents of a directory src to a directory dest. If a file in src already exists in dest then the one in dest will be blindly overwritten. NOTE: the source directory cannot change while this method is running. Otherwise the results are undefined. More...

## Additional Inherited Members

Static Public Attributes inherited from Lucene::FSDirectory
static const int32_t | DEFAULT_READ_CHUNK_SIZE
| Default read chunk size. This is a conditional default based on operating system. More...
Protected Member Functions inherited from Lucene::FSDirectory
| FSDirectory (const String &path, const LockFactoryPtr &lockFactory)
| Create a new FSDirectory for the named location (ctor for subclasses). More...
void | initOutput (const String &name)
| Initializes the directory to create a new file with the given name. This method should be used in createOutput. More...
Protected Member Functions inherited from Lucene::Directory
void | ensureOpen ()
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()
Protected Attributes inherited from Lucene::FSDirectory
bool | checked
String | directory
| The underlying filesystem directory. More...
int32_t | chunkSize
Protected Attributes inherited from Lucene::Directory
bool | isOpen
LockFactoryPtr | lockFactory
| Holds the LockFactory instance (implements locking for this Directory instance). More...
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

A straightforward implementation of FSDirectory using std::ofstream and std::ifstream.

## Constructor & Destructor Documentation

## ◆ SimpleFSDirectory()

Lucene::SimpleFSDirectory::SimpleFSDirectory | ( | const String & | path,
|  | const LockFactoryPtr & | lockFactory = `LockFactoryPtr()`
| ) |  |

Create a new SimpleFSDirectory for the named location and NativeFSLockFactory.

Parameters

  path | the path of the directory.
  lockFactory | the lock factory to use, or null for the default (NativeFSLockFactory)

## ◆ ~SimpleFSDirectory()

virtual Lucene::SimpleFSDirectory::~SimpleFSDirectory | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::SimpleFSDirectory::_getClassName | ( |  | ) |

inline static

## ◆ createOutput()

virtual IndexOutputPtr Lucene::SimpleFSDirectory::createOutput | ( | const String & | name | ) |

virtual

Creates an IndexOutput for the file with the given name.

Implements Lucene::Directory.

## ◆ getClassName()

virtual String Lucene::SimpleFSDirectory::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::FSDirectory.

## ◆ openInput() [1/2]

virtual IndexInputPtr Lucene::SimpleFSDirectory::openInput | ( | const String & | name | ) |

virtual

Returns a stream reading an existing file, with the specified read buffer size. The particular Directory implementation may ignore the buffer size.

Reimplemented from Lucene::FSDirectory.

## ◆ openInput() [2/2]

virtual IndexInputPtr Lucene::SimpleFSDirectory::openInput | ( | const String & | name,
|  | int32_t | bufferSize
| ) |  |

virtual

Creates an IndexInput for the file with the given name.

Reimplemented from Lucene::FSDirectory.

## ◆ shared_from_this()

boost::shared_ptr< SimpleFSDirectory > Lucene::SimpleFSDirectory::shared_from_this | ( |  | ) |

inline

The documentation for this class was generated from the following file:

- SimpleFSDirectory.h

clucene.sourceforge.net